#!/bin/sh
#post-install script.
#Puppy Linux
#assume current directory is rootfs-complete, which has the final filesystem.
#this script is similar to the post-install scripts of the window managers.
#Keywords are located in the Help page and the lines uncommented.
#DISTRO_VERSION is global variable visible here.

WKGDIR="`pwd`"

#CONFIGFILE="usr/share/doc/index.html"
#CONFIGBASE="index.html"
#CONFIGFILE="usr/share/doc/index-skeleton-top"
CONFIGFILE="usr/share/doc/index.html.top"
CONFIGFILEBOTTOM="usr/share/doc/index.html.bottom"
echo "Configuring Puppy skeleton..."

#cleanup...
rm -f /tmp/fbvideomode.txt


##/tmp/keywords.txt has all the keywords read from file "keyword" in each package.
#KEYWORDS="`cat /tmp/keywords.txt`"
#NUMKEYS="`wc -w /tmp/keywords.txt | tr -s " " | cut -f 2 -d " "`"

##number lines in the config file...
#NUMLINES="`wc -l $CONFIGFILE | tr -s " " | cut -f 2 -d " "`"

#update Puppy version number...
echo -n "$DISTRO_VERSION" > etc/puppyversion #for backward compatibility.
DIGIT1="`echo "$DISTRO_VERSION" | cut -b 1`"
DIGIT2="`echo "$DISTRO_VERSION" | cut -b 2`"
DIGIT3="`echo "$DISTRO_VERSION" | cut -b 3`"
RIGHTVER="${DIGIT1}.${DIGIT2}.${DIGIT3}"
[ "$DIGIT3" = "0" ] && RIGHTVER="${DIGIT1}.${DIGIT2}"

echo "Configuring Puppy Help page..."

echo "Writing version number and distro name to Help page..."
#insert the version number into file...
EDITTEXT="s/DISTRO_VERSION/$RIGHTVER/g"
distronamePATTERN="s/DISTRO_NAME/${DISTRO_NAME}/g" #w002 see file DISTRO_SPECS.
cat $CONFIGFILE | sed -e "$EDITTEXT" | sed -e "$distronamePATTERN" > /tmp/puphelppage.htm
cat $CONFIGFILEBOTTOM | sed -e "$EDITTEXT" | sed -e "$distronamePATTERN" > /tmp/puphelppagebottom.htm
sync
cp -f /tmp/puphelppage.htm $CONFIGFILE
cp -f /tmp/puphelppagebottom.htm $CONFIGFILEBOTTOM
sync


#insert date into file...
echo "Writing the date to Help page..."
PUPPYDATE="`date | tr -s " " | cut -f 2,6 -d " "`"
EDITTEXT="s/PUPPYDATE/$PUPPYDATE/g"
cat $CONFIGFILE | sed -e "$EDITTEXT" > /tmp/puphelppage.htm
sync
cp -f /tmp/puphelppage.htm $CONFIGFILE
sync

##############

##v1.0.5
#echo "The number of keywords to process is $NUMKEYS."
#echo "Processing keywords (this may take awhile!)..."
#cp -f ./usr/share/doc/index.html ./root/.index.html
#sync
#for ONEKEY in $KEYWORDS
#do
# #echo -n " $ONEKEY"
# /usr/sbin/fixmenus $WKGDIR/root $ONEKEY index
#done
#sync
#cp -f ./root/.index.html ./usr/share/doc/index.html
#echo "...rootfs-complete/$CONFIGFILE file has been processed."

##v2.14...
##./usr/sbin/indexgen.sh relative
#chroot `pwd` /usr/sbin/indexgen.sh
#...NO, have to do this in createpuppy, after packages.txt copied to rootfs-complete.

#echo "The default kernel for Puppy is vmlinuz."
echo -n "vmlinuz" > /tmp/vmlinuzforpup.txt
#note, createpuppy will read this.

#end#
